require "bundler/setup"
require 'pathname'

require_relative 'fabriq/cli'
require_relative 'fabriq/logging'
require_relative 'fabriq/adapter'
require_relative 'fabriq/config'
require_relative 'fabriq/plugin_port'
require_relative 'fabriq/skype'
require_relative 'fabriq/skype_proxy'

module Fabriq
  extend self

  def root
    Pathname.new(File.expand_path(File.join(File.dirname(__FILE__), "..")))
  end

  def config(&block)
    yield Fabriq::Config
  end

  def boot
    Fabriq::Config.load
    Fabriq::Adapter.load
    Fabriq::Adapter.run { load_environment }
  end

  def argv
    ARGV
  end

  def load_environment
    if self.argv.size > 0
      Fabriq::CLI.run(self.argv)
    else
      Fabriq::PluginPort.initialize_plugins
    end
  end
end

# Empty namespace for plugins
module Plugins; end