module Fabriq
  module Logging

    def config
      Fabriq::Config
    end

    def info(msg)
      send_output :info, msg
    end

    def error(msg)
      send_output :error, msg
    end

    def debug(msg)
      send_output :debug, msg
    end

    def send_output(level, msg)
      return if self.config.runtime_env == "test"
      puts "#{Time.now.to_s} - #{level.upcase} : #{msg}"
    end

  end
end